//Constants
//var MAX_CATEGORY_LIST_COLS = 6;
var MAX_CATEGORIES_COLS = 6;
var MAX_CATEGORIES_ROWS = 3;
//var MAX_CATEGORY_COLS = 6;
var MAX_SORT_VIDEOS_COLS = 6;
var MAX_SORT_VIDEOS_ROWS = 2;
//var MAX_VIDEO_CATEGORY_COLS = 3;
var MAX_SEE_ALSO_VIDEOS_COLS = 3;
var MAX_SEE_ALSO_VIDEOS_ROWS = 3;
var ACTIVE_SEE_ALSO_VIDEOS_ROWS = 2;
var SECONDS_IN_MINUTE = 60;
var SECONDS_IN_HOUR = 3600;
var MINUTES_IN_HOUR = 60;
var FILTER_ITEMS_COUNT = 6;
var FIRST_SORT_ITEM = 0;
var LAST_SORT_ITEM = 1;
var FIRST_FILTER_ITEM = 2;
var LAST_FILTER_ITEM = 5;
var FILTER_STEP = 1;
var PLAYER_STOPPED = 0;
var PLAYER_PLAYING = 1;
var PLAYER_PAUSED = 2;
var YES = "Y";
var NO = "N";
var MAX_TRIMMED_TITLE_LENGTH = 15;
var MAX_EXTENDED_TITLE_LENGTH = 85;
var MAX_RATING = 5;
var POINT_IN_STAR = 20;
//var SORT_BY_VIEWS = 0;

var SORT_BY_DATE = 0;
var SORT_BY_RAITING = 1;
var FILTER_TODAY = 2;
var FILTER_WEEK = 3;
var FILTER_MONTH = 4;
var FILTER_ALL_TIME = 5;
var SORT_FILTER_TITLES = [//"По количеству просмотров",
                          "По дате добавления",
                          "По рейтингу",
                          " за сегодня", 
                          " за неделю", 
                          " за месяц", 
                          " за все время"];
var RUSSIAN_MONTHS = ["Января", 
                      "Февраля", 
                      "Марта", 
                      "Апреля", 
                      "Мая", 
                      "Июня", 
                      "Июля", 
                      "Августа", 
                      "Сентября", 
                      "Октября", 
                      "Ноября", 
                      "Декабря"];
var FORWARD = 1;
var BACKWARD = -1;  
var SORT_VIDEOS_SCROLL_TOP = 93;
var SORT_VIDEOS_SCROLL_LENGTH = 378; 
var SORT_VIDEOS_SCROLL_DIV_PREFIX = "sort_videos"; 
var CATEGORIES_SCROLL_TOP = 108;
var CATEGORIES_SCROLL_LENGTH = 360;
var CATEGORIES_SCROLL_DIV_PREFIX = "categories";
var SEE_ALSO_SCROLL_TOP = 27;
var SEE_ALSO_SCROLL_LENGTH = 457;
var SEE_ALSO_SCROLL_DIV_PREFIX = "see_also";                  
var KEY_INTERNET_TV = 147; //really don't know why 147 but it works 
var KEY_SMART_HUB = 261;
var VIDEO_INFO_VISIBLE = true;
var VIDEO_INFO_INVISIBLE = false;   
var TV_PRODUCT_TYPE_AV = 2;  
var AUDIO_VOLUME_KEY_UP = 0;
var AUDIO_VOLUME_KEY_DOWN = 1;
var ONE_VOLUME_STEP_WIDTH = 3;
         
//objects
var controller = null;
var controller_categories = null;
var controller_sort_videos = null;
var controller_see_also_videos = null; 
var controller_video = null;
var model_videos = null;
var model_video = null;
var model_categories = null;
var IS_AV_APPLICATION = null;


var view = null;
var mute_state = false;
var user_mute_state = false;
var tvKey = new Common.API.TVKeyValue();
var widgetAPI = new Common.API.Widget(); 
var pluginAPI = new Common.API.Plugin();
var page_element_association = {
    category: "video",
    category_list: "category",
    video: "video",
    video_category: "video"
}

var smart_return = new return_stack();

//utils
function format_time(time_in_seconds){
    var time_in_hh_mm_ss_format = "";
    var seconds = time_in_seconds % SECONDS_IN_MINUTE; //seconds
    if (seconds < 10){
        seconds = "0" + seconds;
    }
    var hours = (time_in_seconds - (time_in_seconds % SECONDS_IN_HOUR))/SECONDS_IN_HOUR;
    var minutes = (time_in_seconds - (time_in_seconds % SECONDS_IN_MINUTE))/SECONDS_IN_MINUTE - hours*MINUTES_IN_HOUR;
    if (hours > 0){
        time_in_hh_mm_ss_format = hours + ":";
        if (minutes < 10){
            minutes = "0" + minutes;
        }
    }    
    time_in_hh_mm_ss_format += minutes + ":" + seconds;
    return time_in_hh_mm_ss_format;
}

function format_time_to_phrase(time_in_seconds){
    var time_in_hh_mm_ss_format = "";
    var seconds = time_in_seconds % SECONDS_IN_MINUTE; //seconds
    var hours = (time_in_seconds - (time_in_seconds % SECONDS_IN_HOUR))/SECONDS_IN_HOUR;
    var minutes = (time_in_seconds - (time_in_seconds % SECONDS_IN_MINUTE))/SECONDS_IN_MINUTE - hours*MINUTES_IN_HOUR;
    if (hours > 0){
        switch (hours) {
            case 1:
                time_in_hh_mm_ss_format = hours + " час ";
                break;
            case "2":
                time_in_hh_mm_ss_format = hours + " часа ";
                break;
            case "3":
                time_in_hh_mm_ss_format = hours + " часа ";
                break;
            case "4":
                time_in_hh_mm_ss_format = hours + " часа ";
                break;    
            default:
                time_in_hh_mm_ss_format = hours + " часов ";
        }
    } 
    if (minutes > 0){    
        time_in_hh_mm_ss_format += minutes + " мин. "
    }
    if (seconds > 0){
        time_in_hh_mm_ss_format += seconds + " сек.";
    }    
    return time_in_hh_mm_ss_format;
}

function trim_string(string, max_chars, ellipsis){
    var counter = max_chars;
    if (ellipsis == "Y") {
        counter = max_chars - 3;
    }
    // searching a long word
    if (max_chars > MAX_TRIMMED_TITLE_LENGTH) {
        var space_pos = -1;
        for (var counter1 = 0; counter1 <= counter; counter1++){
            if ((string.charAt(counter1) == ' ') | (counter1 == counter)){
                var word_length = counter1 - space_pos - 1;
                if (word_length > MAX_TRIMMED_TITLE_LENGTH){
                    var sub_string1 = string.substr(0, space_pos + MAX_TRIMMED_TITLE_LENGTH);
                    var sub_string2 = string.substr(space_pos + MAX_TRIMMED_TITLE_LENGTH);
                    string = sub_string1 + " " + sub_string2;
                    space_pos = space_pos + MAX_TRIMMED_TITLE_LENGTH;
                } else {
                    space_pos = counter1;
                }
            }
        }
    }
    // smart string cutting
	if (string.length <= max_chars) {
		return string;
	} else {
		for (var counter2 = counter; counter2 > 0; counter2--){
			if (string.charAt(counter2) == ' '){
				string = string.substring(0,counter2);
				if (ellipsis == "Y") {
					string = string + '...';
				}
				return string;	
			}
		}
		if (ellipsis == "Y") {
			string = string.substring(0, max_chars - 3) + '...';
		} else {
			string = string.substring(0, max_chars);
		}
		return string;
	}
}

function extend(Child, Parent) {
	var F = function() { }
	F.prototype = Parent.prototype
	Child.prototype = new F()
	Child.prototype.constructor = Child
	Child.superclass = Parent.prototype
}
function get_next_element_number(item_id, key_code, max_cols, max_active_row, see_also_corrector){  
    switch (key_code) {
        case tvKey.KEY_LEFT: 
            if (item_id > 0) 
                item_id--;
            if (item_id == model_video.item_id)
                item_id -= see_also_corrector;
            break;
            
        case tvKey.KEY_RIGHT:
            var saved_item_id = item_id;
            if (item_id < model_videos.filtered_current_videos_count - 1)
                item_id++;    
            if (item_id == model_video.item_id)
                item_id += see_also_corrector;  
            if (item_id > model_videos.filtered_current_videos_count - 1)
                item_id = saved_item_id;
            break;
            
        case tvKey.KEY_UP:
            if (((item_id - model_video.item_id) < max_cols)&&(item_id > model_video.item_id)){
                 if (item_id - max_cols > 0){
                    item_id -= see_also_corrector;
                    item_id = item_id - max_cols;   
                 }
            } else { 
                if (item_id - max_cols >= 0)
                    item_id = item_id - max_cols;  
            }  
            break;
        case tvKey.KEY_DOWN:
            if ((item_id < model_video.item_id) && (model_video.item_id <= item_id + max_cols ))
                item_id += see_also_corrector;  
            if (item_id + max_cols < model_videos.filtered_current_videos_count){
                item_id = item_id + max_cols; 
            } else {
                var last_item_row = Math.floor((model_videos.filtered_current_videos_count - 1)/max_cols) + 1;
                var current_item_row = Math.floor((item_id)/max_cols) + 1;
                if (last_item_row > current_item_row){
                    item_id = model_videos.filtered_current_videos_count - 1;
                }    
            }
            break;    
    }
    return item_id;
}

function refresh_view(item_id, first_item_id, max_cols, max_active_row, see_also_corrector){    
    var right_bound = first_item_id + max_cols * max_active_row - 1;
    if ((first_item_id < model_video.item_id) && (model_video.item_id <= right_bound))
        right_bound += see_also_corrector;
    return ((item_id < first_item_id) || (item_id > right_bound));    
}

function get_first_item_id(item_id, key_code, max_cols, first_item_id, see_also_corrector){    
    if ((key_code == tvKey.KEY_LEFT) || (key_code == tvKey.KEY_UP)) { 
        first_item_id = first_item_id - max_cols; 
        if ((first_item_id <= model_video.item_id)&&(model_video.item_id < item_id))
            first_item_id -= see_also_corrector;
        
    }            
        
    if ((key_code == tvKey.KEY_DOWN) || (key_code == tvKey.KEY_RIGHT) ){
        if ((first_item_id < model_video.item_id)&(model_video.item_id <= first_item_id + max_cols)) 
            first_item_id += see_also_corrector;
        first_item_id += max_cols;
    }
    return first_item_id;    
}

function get_first_item_id_for_scrolling(item_id,
                                         max_cols, 
                                         max_rows, 
                                         first_item_id, 
                                         key_code, 
                                         max_active_row) {
                                     
    if (max_active_row == null) {
        see_also_corrector  = 0;
        max_active_row = max_rows;
    } else see_also_corrector  = 1;    
    var new_active_item_id = get_next_element_number(item_id, key_code, max_cols, max_active_row, see_also_corrector);
    global_videos.current_video = new_active_item_id;    
    var need_refresh = refresh_view(new_active_item_id, first_item_id, max_cols, max_active_row, see_also_corrector);
    var new_first_item_id = first_item_id;
    if (need_refresh){
        new_first_item_id = get_first_item_id(item_id, key_code, max_cols, first_item_id, see_also_corrector);
    }
    //alert("new item id="+new_active_item_id+" need refresh = "+need_refresh + " first item = "+ new_first_item_id);
    return new_first_item_id;    
}


function format_date_time(date_string){
    var year = date_string.substr(0,4);
    var month = date_string.substr(5,2) - 1;
    var day = date_string.substr(8,2);
    var hours = date_string.substr(11,2);
    var minutes = date_string.substr(14,2);
    var seconds = date_string.substr(17,2);
    var UTC_zone_hours = date_string.substr(20,2);
    var UTC_zone_minutes = date_string.substr(22,2);
    var UTC_zone_difference = date_string.substr(19,1);
    var curr_date = new Date();
    var tiemzone_offset = -curr_date.getTimezoneOffset();
    var greenwich_time = "";
    if (UTC_zone_difference == "+"){
        return new Date(year, month, day, hours - UTC_zone_hours, minutes - UTC_zone_minutes + tiemzone_offset, seconds);
    } else {
        return new Date(year, month, day, hours + UTC_zone_hours, minutes + UTC_zone_minutes + tiemzone_offset, seconds);
    }      
}

function get_russian_date(date_in_milliseconds){
    return date_in_milliseconds.getDate() + " " + 
           RUSSIAN_MONTHS[date_in_milliseconds.getMonth()] + " " + 
           date_in_milliseconds.getFullYear();    
}

function track_bar_drawing(item_id, displayed_cols, displayed_rows, count, window_height, start_tracker_position, div_prefix, played_video_id) {
    if (count <= (displayed_cols * displayed_rows)) {
        $("#" + div_prefix + "_scrolling").hide();
    } else {
        $("#" + div_prefix + "_scrolling").show();
        if (played_video_id == null){
            var tracker_height = window_height / Math.ceil(count / displayed_cols);
        } else {
            var tracker_height = window_height / Math.ceil((count - 1) / displayed_cols);
        }
        if (played_video_id == null){
            var active_row = Math.floor(item_id / displayed_cols) + 1;
        } else {
            if (played_video_id < item_id){
                var active_row = Math.floor((item_id - 1) / displayed_cols) + 1;
            } else {
                var active_row = Math.floor(item_id / displayed_cols) + 1;
            }
        }
        var tracker_position = start_tracker_position + tracker_height * (active_row - 1) ;
        $("#" + div_prefix + "_scrolling").height(tracker_height);
        $("#" + div_prefix + "_scrolling").css({"top": tracker_position});
        if (tracker_height < 8) tracker_height = 0
        else tracker_height = tracker_height - 8;
        $("#" + div_prefix + "_scroll_body").height(tracker_height); 
    }
    
}

function html_decode_16(s) {
    var arr1 = ["&#x22;","&#x26;","&#x3C;","&#x3E;","&#x152;","&#x153;","&#x160;","&#x161;","&#x178;","	&#x2C6;",
                "&#x2DC;","&#x2002;","&#x2003;","&#x2009;","&#x200C;","&#x200D;","&#x200E;","&#x200F;","&#x2013;","&#x2014;",
                "&#x2018;","&#x2019;","&#x201A;","&#x201C;","&#x201D;","&#x201E;","&#x2020;","&#x2021;","&#x2030;","&#x2039",
                "&#x203A;","&#x20AC;",
                //Latin's symbols
                "&#xA0;","&#xA1;","&#xA2;","&#xA3;","&#xA4;","&#xA5;","&#xA6;","&#xA7;","&#xA8;","&#xA9;","&#xAA;","&#xAB;","&#xAC;","&#xAD;","&#xAE;","&#xAF;",
                "&#xB0;","&#xB1;","&#xB2;","&#xB3;","&#xB4;","&#xB5;","&#xB6;","&#xB7;","&#xB8;","&#xB9;","&#xBA;","&#xBB;","&#xBC;","&#xBD;","&#xBE;","&#xBF;",
                "&#xC0;","&#xC1;","&#xC2;","&#xC3;","&#xC4;","&#xC5;","&#xC6;","&#xC7;","&#xC8;","&#xC9;","&#xCA;","&#xCB;","&#xCC;","&#xCD;","&#xCE;","&#xCF;",
                "&#xD0;","&#xD1;","&#xD2;","&#xD3;","&#xD4;","&#xD5;","&#xD6;","&#xD7;","&#xD8;","&#xD9;","&#xDA;","&#xDB;","&#xDC;","&#xDD;","&#xDE;","&#xDF;",
                "&#xE0;","&#xE1;","&#xE2;","&#xE3;","&#xE4;","&#xE5;","&#xE6;","&#xE7;","&#xE8;","&#xE9;","&#xEA;","&#xEB;","&#xEC;","&#xED;","&#xEE;","&#xEF;",
                "&#xF0;","&#xF1;","&#xF2;","&#xF3;","&#xF4;","&#xF5;","&#xF6;","&#xF7;","&#xF8;","&#xF9;","&#xFA;","&#xFB;","&#xFC;","&#xFD;","&#xFE;","&#xFF;",
                // Math symbols and Greece symbols
                "&#x192;","&#x391;","&#x392;","&#x393;","&#x394;","&#x395;","&#x396;","&#x397;","&#x398;","&#x399;","&#x39A;","&#x39B;","&#x39C;","&#x39D;",
                "&#x39E;","&#x39F;","&#x3A0;","&#x3A1;","&#x3A3;","&#x3A4;","&#x3A5;","&#x3A6;","&#x3A7;","&#x3A8;","&#x3A9;","&#x3B1;","&#x3B2;","&#x3B3;",
                "&#x3B4;","&#x3B5;","&#x3B6;","&#x3B7;","&#x3B8;","&#x3B9;","&#x3BA;","&#x3BB;","&#x3BC;","&#x3BD;","&#x3BE;","&#x3BF;","&#x3C0;","&#x3C1;",
                "&#x3C2;","&#x3C3;","&#x3C4;","&#x3C5;","&#x3C6;","&#x3C7;","&#x3C8;","&#x3C9;","&#x3D1;","&#x3D2;","&#x3D6;","&#x2022;","&#x2026;","&#x2032;",
                "&#x2033;","&#x203E;","&#x2044;","&#x2118;","&#x2111;","&#x211C;","&#x2122;","&#x2135;","&#x2190;","&#x2191;","&#x2192;","&#x2193;","&#x2194;",
                "&#x21B5;","&#x21D0;","&#x21D1;","&#x21D2;","&#x21D3;","&#x21D4;","&#x2200;","&#x2202;","&#x2203;","&#x2205;","&#x2207;","&#x2208;","&#x2209;",
                "&#x220B;","&#x220F;","&#x2211;","&#x2212;","&#x2217;","&#x221A;","&#x221D;","&#x221E;","&#x2220;","&#x2227;","&#x2228;","&#x2229;","&#x222A;",
                "&#x222B;","&#x2234;","&#x223C;","&#x2245;","&#x2248;","&#x2260;","&#x2261;","&#x2264;","&#x2265;","&#x2282;","&#x2283;","&#x2284;","&#x2286;",
                "&#x2287;","&#x2295;","&#x2297;","&#x22A5;","&#x22C5;","&#x2308;","&#x2309;","&#x230A;","&#x230B;","&#x2329;","&#x232A;","&#x25CA;","&#x2660;",
                "&#x2663;","&#x2665;","&#x2666;"];
    
    var arr2 = ["&quot;","&","&lt;","&gt;","&OElig;","&oelig;","&Scaron;","&scaron;","&Yuml;","&circ;" ,
                "˜˜˜˜˜˜˜˜˜&tilde;","&ensp;","&emsp;","&thinsp;","&zwnj;","&zwj;","&lrm;","&rlm;","&ndash;","&mdash;",
                "&lsquo;","&rsquo;","&sbquo;","&ldquo;","&rdquo;","&bdquo;","&dagger;","&Dagger;","&permil;","&lsaquo;",
                "&rsaquo;","&euro;",
                //Latin's symbols
                "&nbsp;","&iexcl;","&cent;","&pound;","&curren;","&yen;","&brvbar;","&sect;","&uml;","&copy;","&ordf;","&laquo;","&not;","&shy;","&reg;","&macr;",
                "&deg;","&plusmn;","&sup2;","&sup3;","&acute;","&micro;","&para;","&middot;","&cedil;","&sup1;","&ordm;","&raquo;","&frac14;","&frac12;","&frac34;",
                "&iquest;","&Agrave;","&Aacute;","&Acirc;","&Atilde;","&Auml;","&Aring;","&AElig;","&Ccedil;","&Egrave;","&Eacute;","&Ecirc;","&Euml;","&Igrave;",
                "&Iacute;","&Icirc;","&Iuml;","&ETH;","&Ntilde;","&Ograve;","&Oacute;","&Ocirc;","&Otilde;","&Ouml;","&times;","&Oslash;","&Ugrave;","&Uacute;",
                "&Ucirc;","&Uuml;","&Yacute;","&THORN;","&szlig;","&agrave;","&aacute;","&acirc;","&atilde;","&auml;","&aring;","&aelig;","&ccedil;","&egrave;",
                "&eacute;","&ecirc;","&euml;","&igrave;","&iacute;","&icirc;","&iuml;","&eth;","&ntilde;","&ograve;","&oacute;","&ocirc;","&otilde;","&ouml;",
                "&divide;","&oslash;","&ugrave;","&uacute;","&ucirc;","&uuml;","&yacute;","&thorn;","&yuml;",
                // Math symbols and Greece symbols
                "&fnof;","&Alpha;","&Beta;","&Gamma;","&Delta;","&Epsilon;","&Zeta;","&Eta;","&Theta;","&Iota;","&Kappa;","&Lambda;","&Mu;","&Nu;","&Xi;","&Omicron;",
                "&Pi;","&Rho;","&Sigma;","&Tau;","&Upsilon;","&Phi;","&Chi;","&Psi;","&Omega;","&alpha;","&beta;","&gamma;","&delta;","&epsilon;","&zeta;","&eta;",
                "&theta;","&iota;","&kappa;","&lambda;","&mu;","&nu;","&xi;","&omicron;","&pi;","&rho;","&sigmaf;","&sigma;","&tau;","&upsilon;","&phi;","&chi;",
                "&psi;","&omega;","&thetasym;","&upsih;","&piv;","&bull;","&hellip;","&prime;","&Prime;","&oline;","&frasl;","&weierp;","&image;","&real;","&trade;",
                "&alefsym;","&larr;","&uarr;","&rarr;","&darr;","&harr;","&crarr;","&lArr;","&uArr;","&rArr;","&dArr;","&hArr;","&forall;","&part;","&exist;","&empty;",
                "&nabla;","&isin;","&notin;","&ni;","&prod;","&sum;","&minus;","&lowast;","&radic;","&prop;","&infin;","&ang;","&and;","&or;","&cap;","&cup;","&int;",
                "&there4;","&sim;","&cong;","&asymp;","&ne;","&equiv;","&le;","&ge;","&sub;","&sup;","&nsub;","&sube;","&supe;","&oplus;","&otimes;","&perp;","&sdot;",
                "&lceil;","&rceil;","&lfloor;","&rfloor;","&lang;","&rang;","&loz;","&spades;","&clubs;","&hearts;","&diams;"];
                
    var re;
    for(var x=0,i=arr1.length;x<i;x++){
		re = new RegExp(arr1[x], 'g');
		s = s.replace(re,arr2[x]);
	}
	return s;
}

function html_decode_10(s) {
    var arr1 = ["&#34;","&#38","&#60;","&#62;","&#338;","&#339;","&#352;","	&#353;","&#376;","&#710;",
                "&#732;","&#8194;","&#8195;","&#8201;","&#8204;","&#8205;","&#8206;","&#8207;","&#8211;","&#8212;",
                "&#8216;","&#8217;","&#8218;","&#8220;","&#8221;","&#8222;","&#8224;","&#8225;","&#8240;","&#8249;",
                "&#8250;","&#8364;",
                //Latin's symbols
                "&#160;","&#161;","&#162;","&#163;","&#164;","&#165;","&#166;","&#167;","&#168;","&#169;","&#170;","&#171;","&#172;","&#173;","&#174;","&#175;",
                "&#176;","&#177;","&#178;","&#179;","&#180;","&#181;","&#182;","&#183;","&#184;","&#185;","&#186;","&#187;","&#188;","&#189;","&#190;","&#191;",
                /*"&#192;","&#193;","&#194;","&#195;","&#196;","&#197;","&#198;","&#199;","&#200;","&#201;","&#202;","&#203;","&#204;","&#205;","&#206;","&#207;",
                "&#208;","&#209;","&#210;","&#211;","&#212;","&#213;","&#214;","&#215;","&#216;","&#217;","&#218;","&#219;","&#220;","&#221;","&#222;","&#223;",
                "&#224;","&#225;","&#226;","&#227;","&#228;","&#229;","&#230;","&#231;","&#232;","&#233;","&#234;","&#235;","&#236;","&#237;","&#238;","&#239;",
                "&#240;","&#241;","&#242;","&#243;","&#244;","&#245;","&#246;","&#247;","&#248;","&#249;","&#250;","&#251;","&#252;","&#253;","&#254;","&#255;",*/
                // Math symbols and Greece symbols
                "&#402;",/*"&#913;","&#914;","&#915;","&#916;","&#917;","&#918;","&#919;","&#920;","&#921;","&#922;","&#923;","&#924;","&#925;","&#926;","&#927;",
                "&#928;","&#929;","&#931;","&#932;","&#933;","&#934;","&#935;","&#936;","&#937;","&#945;","&#946;","&#947;","&#948;","&#949;","&#950;","&#951;",
                "&#952;","&#953;","&#954;","&#955;","&#956;","&#957;","&#958;","&#959;","&#960;","&#961;","&#962;","&#963;","&#964;","&#965;","&#966;","&#967;",
                "&#968;","&#969;","&#977;","&#978;","&#982;",*/"&#8226;","&#8230;","&#8242;","&#8243;","&#8254;","&#8260;","&#8472;","&#8465;","&#8476;","&#8482;",
                /*"&#8501;","&#8592;","&#8593;","&#8594;","&#8595;","&#8596;","&#8629;","&#8656;","&#8657;","&#8658;","&#8659;","&#8660;","&#8704;","&#8706;",
                "&#8707;","&#8709;","&#8711;","&#8712;","&#8713;","&#8715;","&#8719;","&#8721;","&#8722;","&#8727;","&#8730;","&#8733;","&#8734;","&#8736;",
                "&#8743;","&#8744;","&#8745;","&#876;","&#8747;","&#8756;","&#8764;","&#8773;","&#8776;","&#8800;","&#8801;","&#8804;","&#8805;","&#8834;",
                "&#8835;","&#8836;","&#8838;","&#8839;","&#8853;","&#8855;","&#8869;","&#8901;","&#8968;","&#8969;","&#8970;","&#8971;","&#9001;","&#9002;",
                "&#9674;",*/"&#9824;","&#9827;","&#9829;","&#9830;"];
                
    var arr2 = ["&quot;","&amp;","&lt;","&gt;","&OElig;","&oelig;","&Scaron;","&scaron;","&Yuml;","&circ;" ,
                "˜˜˜˜˜˜˜˜˜&tilde;","&ensp;","&emsp;","&thinsp;","&zwnj;","&zwj;","&lrm;","&rlm;","&ndash;","&mdash;",
                "&lsquo;","&rsquo;","&sbquo;","&ldquo;","&rdquo;","&bdquo;","&dagger;","&Dagger;","&permil;","&lsaquo;",
                "&rsaquo;","&euro;",
                //Latin's symbols
                "&nbsp;","&iexcl;","&cent;","&pound;","&curren;","&yen;","&brvbar;","&sect;","&uml;","&copy;","&ordf;","&laquo;","&not;","&shy;","&reg;","&macr;",
                "&deg;","&plusmn;","&sup2;","&sup3;","&acute;","&micro;","&para;","&middot;","&cedil;","&sup1;","&ordm;","&raquo;","&frac14;","&frac12;","&frac34;",
                "&iquest;",/*"&Agrave;","&Aacute;","&Acirc;","&Atilde;","&Auml;","&Aring;","&AElig;","&Ccedil;","&Egrave;","&Eacute;","&Ecirc;","&Euml;","&Igrave;",
                "&Iacute;","&Icirc;","&Iuml;","&ETH;","&Ntilde;","&Ograve;","&Oacute;","&Ocirc;","&Otilde;","&Ouml;","&times;","&Oslash;","&Ugrave;","&Uacute;",
                "&Ucirc;","&Uuml;","&Yacute;","&THORN;","&szlig;","&agrave;","&aacute;","&acirc;","&atilde;","&auml;","&aring;","&aelig;","&ccedil;","&egrave;",
                "&eacute;","&ecirc;","&euml;","&igrave;","&iacute;","&icirc;","&iuml;","&eth;","&ntilde;","&ograve;","&oacute;","&ocirc;","&otilde;","&ouml;",
                "&divide;","&oslash;","&ugrave;","&uacute;","&ucirc;","&uuml;","&yacute;","&thorn;","&yuml;",*/
                // Math symbols and Greece symbols
                "&fnof;",/*"&Alpha;","&Beta;","&Gamma;","&Delta;","&Epsilon;","&Zeta;","&Eta;","&Theta;","&Iota;","&Kappa;","&Lambda;","&Mu;","&Nu;","&Xi;","&Omicron;",
                "&Pi;","&Rho;","&Sigma;","&Tau;","&Upsilon;","&Phi;","&Chi;","&Psi;","&Omega;","&alpha;","&beta;","&gamma;","&delta;","&epsilon;","&zeta;","&eta;",
                "&theta;","&iota;","&kappa;","&lambda;","&mu;","&nu;","&xi;","&omicron;","&pi;","&rho;","&sigmaf;","&sigma;","&tau;","&upsilon;","&phi;","&chi;",
                "&psi;","&omega;","&thetasym;","&upsih;","&piv;",*/"&bull;","&hellip;","&prime;","&Prime;","&oline;","&frasl;","&weierp;","&image;","&real;","&trade;",
                /*"&alefsym;","&larr;","&uarr;","&rarr;","&darr;","&harr;","&crarr;","&lArr;","&uArr;","&rArr;","&dArr;","&hArr;","&forall;","&part;","&exist;","&empty;",
                "&nabla;","&isin;","&notin;","&ni;","&prod;","&sum;","&minus;","&lowast;","&radic;","&prop;","&infin;","&ang;","&and;","&or;","&cap;","&cup;","&int;",
                "&there4;","&sim;","&cong;","&asymp;","&ne;","&equiv;","&le;","&ge;","&sub;","&sup;","&nsub;","&sube;","&supe;","&oplus;","&otimes;","&perp;","&sdot;",
                "&lceil;","&rceil;","&lfloor;","&rfloor;","&lang;","&rang;","&loz;",*/"&spades;","&clubs;","&hearts;","&diams;"];
    var re;
    for(var x=0,i=arr1.length;x<i;x++){
		re = new RegExp(arr1[x], 'g');
		s = s.replace(re,arr2[x]);
	}
	return s;
}