var sax_parser = {
    parse: function (xmlAsString) {
        var video_counter = 0;
		var video_id = 0;
		var video_title = 0;
		var video_asset_url = 0;
		var video_image_url = 0;
		var video_description = 0;
		var video_duration = 0;
		var video_popularity = 0;
		var category_name = 0;
        var category_priority = 0;
        var category_image = 0;
        var my_array = xmlAsString.split("<asset>");
        for (video_counter = 1; video_counter < my_array.length; video_counter++){
        //for (video_counter = 1; video_counter < 2; video_counter++){
            video_id = this.get_element_value(my_array[video_counter], "id");
            video_title = this.get_element_value(my_array[video_counter], "title");
            if (video_title.indexOf("&#") >= 0)
                video_title = html_decode_10(video_title.replace(/&#x26;/g, "&"));
            video_asset_url = this.get_element_value(my_array[video_counter], "assetUrl");
            video_image_url = this.get_element_value(my_array[video_counter], "imageUrl");
            //video_rating = this.get_element_value(my_array[video_counter], "rating");
            video_create_date = this.get_element_value(my_array[video_counter], "dateCreated");
            video_create_date = format_date_time(video_create_date);
            video_description = this.get_element_value(my_array[video_counter], "description");
            if (video_description.indexOf("&#") >= 0)
                video_description = html_decode_10(video_description.replace(/&#x26;/g, "&"));
            video_duration = this.get_element_value(my_array[video_counter], "duration");
            video_popularity = this.get_element_value(my_array[video_counter], "popularity");
            video_rating = Math.round(video_popularity/POINT_IN_STAR);
            video_author = this.get_element_value(my_array[video_counter], "author");
            video_size = this.get_element_value(my_array[video_counter], "size");
            video_views = 100; // TEMPORARY!!!!
            category_name = this.get_element_attribute_value(my_array[video_counter], "category", "name");
            category_priority = this.get_element_attribute_value(my_array[video_counter], "category", "priority");
            category_image = this.get_element_attribute_value(my_array[video_counter], "category", "image_std");
            
            var category_num = global_categories.add(category_name, category_priority, category_image);
            global_videos.add(video_id, 
                              video_title, 
                              video_asset_url, 
                              video_image_url, 
                              video_rating, 
                              video_popularity, 
                              video_views, 
                              video_create_date,
                              video_description, 
                              video_duration, 
                              video_author,
                              video_size,
                              category_num);
        }
        model_categories.video_categories.sort(function(value1, value2){
                if (value1.priority > value2.priority) return value2;
                else return value1;
            });
    },        
    
    get_element_value: function (video_element, node_name){
        var element_begin = 0;
        var element_end = 0;
        element_begin = video_element.indexOf("<"+node_name+">")+("<"+node_name+">").length;
        element_end = video_element.indexOf("</"+node_name+">");
        return video_element.substr(element_begin, element_end - element_begin);
    },
    
    get_element_attribute_value: function(video_element, node_name, attribute_name){
        var element_begin = 0;
        var attribute_begin = 0;
        var attribute_end = 0;
        element_begin = video_element.indexOf("<"+node_name)+("<"+node_name+" ").length;
        attribute_begin = video_element.indexOf(attribute_name+"=\"",element_begin)+(attribute_name+"=\"").length;
        attribute_end = video_element.indexOf("\"",attribute_begin);
        return video_element.substr(attribute_begin, attribute_end - attribute_begin);
    }
 } 