function controller_categories_prototype(element_count) {
    this.page = "category_list";
    this.max_column_number = MAX_CATEGORIES_COLS;
    this.max_row_number = MAX_CATEGORIES_ROWS;
    this.element_count = element_count;
    
    this.left_keyDown = function(keyCode, item_id){
        if (item_id > 0) {
            $("#category" + item_id).removeClass("active");
            item_id--;
            $("#category" + item_id).focus();
            $("#category" + item_id).addClass("active");
        };
        track_bar_drawing(item_id, 
                          MAX_CATEGORIES_COLS, 
                          MAX_CATEGORIES_ROWS, 
                          this.element_count, 
                          CATEGORIES_SCROLL_LENGTH, 
                          CATEGORIES_SCROLL_TOP,
                          CATEGORIES_SCROLL_DIV_PREFIX);
    };
    
    this.right_keyDown = function(keyCode, item_id){
        if (item_id < (this.element_count - 1)) {
            $("#category" + item_id).removeClass("active");
            item_id++;
            $("#category" + item_id).focus();
            $("#category" + item_id).addClass("active");
        }
        track_bar_drawing(item_id, 
                          MAX_CATEGORIES_COLS, 
                          MAX_CATEGORIES_ROWS, 
                          this.element_count, 
                          CATEGORIES_SCROLL_LENGTH, 
                          CATEGORIES_SCROLL_TOP,
                          CATEGORIES_SCROLL_DIV_PREFIX);
    };
    
    this.up_keyDown = function(keyCode, item_id){
        if (item_id - this.max_column_number >= 0) {
            $("#category" + item_id).removeClass("active");
            item_id = item_id - this.max_column_number;
            $("#category" + item_id).focus();
            $("#category" + item_id).addClass("active");
        }
        track_bar_drawing(item_id, 
                          MAX_CATEGORIES_COLS, 
                          MAX_CATEGORIES_ROWS, 
                          this.element_count, 
                          CATEGORIES_SCROLL_LENGTH, 
                          CATEGORIES_SCROLL_TOP,
                          CATEGORIES_SCROLL_DIV_PREFIX);
    };
    
    this.down_keyDown = function(keyCode, item_id){
        if (item_id + this.max_column_number < this.element_count) {
            $("#category" + item_id).removeClass("active");
            item_id = item_id + this.max_column_number;
            $("#category" + item_id).focus();
            $("#category" + item_id).addClass("active");
        }
        track_bar_drawing(item_id, 
                          MAX_CATEGORIES_COLS, 
                          MAX_CATEGORIES_ROWS, 
                          this.element_count, 
                          CATEGORIES_SCROLL_LENGTH, 
                          CATEGORIES_SCROLL_TOP,
                          CATEGORIES_SCROLL_DIV_PREFIX);
    }
    
    
}

