function controller_global() {    
    view_categories           = new view_categories_prototype();
    view_sort_videos          = new view_sort_videos_prototype();
    view_video                = new view_video_prototype();
    view_see_also_videos      = new view_see_also_videos_prototype();
    model_videos              = new model_videos_prototype();
    model_video               = new model_video_prototype();
	model_categories		  = new model_categories_prototype();
}
controller_global.prototype = {
    page_name: "",
    category_number: 0,
    video_number: 0
}
controller_global.prototype.init = function(){
    extend(controller_categories_prototype, page_controller);
    controller_categories = new controller_categories_prototype(global_categories.categories_count);
    
    extend(controller_sort_videos_prototype, page_controller);
    controller_sort_videos = new controller_sort_videos_prototype(model_video.video_count);
    
    extend(controller_see_also_videos_prototype, page_controller);
    controller_see_also_videos = new controller_see_also_videos_prototype(model_video.video_count);
    
    extend(controller_video_prototype, page_controller);
    controller_video = new controller_video_prototype();
}

controller_global.prototype.set_category = function(category_num){
    controller_global.category_number = category_num; 
}
controller_global.prototype.set_video = function(video_num){
    controller_global.video_number = video_num; 
}
controller_global.prototype.xml_recieved = function(xml_as_string) {	
	sax_parser.parse(xml_as_string);
    controller_global.prototype.init();
	view_categories.build_view();
    track_bar_drawing(0, 
                      MAX_CATEGORIES_COLS, 
                      MAX_CATEGORIES_ROWS, 
                      global_categories.categories_count, 
                      CATEGORIES_SCROLL_LENGTH, 
                      CATEGORIES_SCROLL_TOP,
                      CATEGORIES_SCROLL_DIV_PREFIX);
}

controller_global.prototype.xml_recieving_error = function(errorString) {
	view_categories.build_view();
}

controller_global.prototype.on_load = function() {
    var TV_plugin = document.getElementById("plugin_object_TV");
    IS_AV_APPLICATION = (TV_plugin.GetProductType() == TV_PRODUCT_TYPE_AV);  
    
	if(!IS_AV_APPLICATION){
        mute_state = document.getElementById("plugin_object_audio").GetUserMute();
        user_mute_state = document.getElementById("plugin_object_audio").GetUserMute();
        document.getElementById("plugin_object_audio").SetUserMute(mute_state);
    }    
    $("#loading").show();
    $("#load_focus").focus();
	send_request();
}
window.onshow = function(){
    pluginAPI.registKey(tvKey.KEY_MENU);
    pluginAPI.registKey(tvKey.KEY_SOURCE);
    pluginAPI.registKey(tvKey.KEY_CHLIST);
}

controller_global.prototype.on_unload = function(){
    document.getElementById("plugin_object_audio").SetUserMute(user_mute_state);
    model_video.deinit();
}

controller_global.prototype.clear_view = function(){
    $("#videos_list").html("");
    $("#category_list").html("");
    $("#see_also").html("");
}

controller_global.prototype.hide_all = function(){
    $("#categories_content").hide();
    $("#sort_videos_content").hide(); 
    $("#see_also_videos_content").hide();
    $("#video_content").hide();
}

controller_global.prototype.keyDown = function(item_id, page_name) {
    controller_global.page_name = page_name;
	var keyCode = event.keyCode;
    event.preventDefault();
    if ($("#loading").css("visibility","").is(":hidden") == false) {
        widgetAPI.blockNavigation(event);
        return;
    }    
    switch (page_name){
		case "category":
			controller_sort_videos.keyDown(keyCode, item_id);
			break;
		case "video_category":
			controller_see_also_videos.keyDown(keyCode, item_id);
			break;
		case "video":
            if (item_id == -1) {
                this.keyDown_video_errors(keyCode);
            } else {
                controller_video.keyDown(keyCode, item_id);
            }    
			break;
		case "category_list":
            if (item_id == -1) {
                this.keyDown_category_errors(keyCode);
            } else {
                controller_categories.keyDown(keyCode, item_id);
            }
			break;  
        default:
            widgetAPI.blockNavigation(event);
	}
}
controller_global.prototype.keyDown_category_errors = function(keyCode){
    switch (keyCode){
        case tvKey.KEY_ENTER:
            this.hide_all();
            $("#loading").show();
            $("#load_focus").focus();
            this.on_load();
            break;
        case tvKey.KEY_RETURN:
            widgetAPI.sendExitEvent();
            break;
        case KEY_SMART_HUB:    
        case KEY_INTERNET_TV:
            widgetAPI.sendExitEvent();
            break; 
    }
}

controller_global.prototype.keyDown_video_errors = function(keyCode){
    switch (keyCode){
        case tvKey.KEY_PLAY:
            controller_video.keyDown(keyCode, global_videos.current_video);
            break;
        case tvKey.KEY_RETURN:
            controller_video.keyDown(keyCode, global_videos.current_video);
            break;
        case KEY_SMART_HUB:    
        case KEY_INTERNET_TV:
            widgetAPI.sendExitEvent();
            break; 
        case tvKey.KEY_RED: 
            global_categories.current_category = 0;
            view_categories.build_view(smart_return.can_go_back);
            break;
    }
}
var controller = new controller_global();
