function controller_sort_videos_prototype(element_count) {
    this.page = "category";
    this.max_column_number = MAX_SORT_VIDEOS_COLS;
    this.max_row_number = MAX_SORT_VIDEOS_ROWS;
    this.element_count = element_count;
	
	this.left_keyDown = function(keyCode, item_id){
        if (item_id < 0)
            return
		if (!model_videos.filter_mode){
			if (item_id > 0) {
                var new_first_video_id = get_first_item_id_for_scrolling(item_id,
                                                                         this.max_column_number, 
                                                                         this.max_row_number, 
                                                                         global_videos.first_video_id, 
                                                                         tvKey.KEY_LEFT);
                
                //get_first_item_id_for_scrolling(item_id, this.max_column_number, this.max_row_number, model_videos.first_video_id, "left");
                if (new_first_video_id != global_videos.first_video_id) {
                    model_videos.first_video_id = new_first_video_id;
                    global_videos.first_video_id = new_first_video_id;
                    view_sort_videos.build_view();
                };
				var trimmed_title = trim_string(model_videos.filtered_current_videos[item_id].video_title, MAX_TRIMMED_TITLE_LENGTH, YES);
				$("#video" + item_id + "_title").html(trimmed_title);
				$("#video" + item_id).removeClass("active");
				item_id--;
                global_videos.current_video = item_id;
				$("#video" + item_id).focus();
				$("#video" + item_id).addClass("active");
				var extend_title = trim_string(model_videos.filtered_current_videos[item_id].video_title, MAX_EXTENDED_TITLE_LENGTH, YES);
				$("#video" + item_id + "_title").html(extend_title);
                
                track_bar_drawing(item_id, 
                                  MAX_SORT_VIDEOS_COLS, 
                                  MAX_SORT_VIDEOS_ROWS, 
                                  model_videos.filtered_current_videos_count, 
                                  SORT_VIDEOS_SCROLL_LENGTH, 
                                  SORT_VIDEOS_SCROLL_TOP,
                                  SORT_VIDEOS_SCROLL_DIV_PREFIX);
			}
		}	
	};
	
	this.right_keyDown = function(keyCode, item_id){
        if (item_id < 0)
            return
		if (!model_videos.filter_mode){
			if (item_id < (model_videos.filtered_current_videos_count-1)) {
                var new_first_video_id = get_first_item_id_for_scrolling(item_id,
                                                                         this.max_column_number, 
                                                                         this.max_row_number, 
                                                                         global_videos.first_video_id, 
                                                                         tvKey.KEY_RIGHT);
                if (new_first_video_id != global_videos.first_video_id) {
                    model_videos.first_video_id = new_first_video_id;
                    global_videos.first_video_id = new_first_video_id;
                    view_sort_videos.build_view();
                };
                var trimmed_title = trim_string(model_videos.filtered_current_videos[item_id].video_title, MAX_TRIMMED_TITLE_LENGTH, YES);
				$("#video" + item_id + "_title").html(trimmed_title);
                $("#video" + item_id).removeClass("active");
				item_id++;
                global_videos.current_video = item_id;
				$("#video" + item_id).focus();
				$("#video" + item_id).addClass("active");
				var extend_title = trim_string(model_videos.filtered_current_videos[item_id].video_title, MAX_EXTENDED_TITLE_LENGTH, YES);
				$("#video" + item_id + "_title").html(extend_title);
                
                track_bar_drawing(item_id, 
                                  MAX_SORT_VIDEOS_COLS, 
                                  MAX_SORT_VIDEOS_ROWS, 
                                  model_videos.filtered_current_videos_count, 
                                  SORT_VIDEOS_SCROLL_LENGTH, 
                                  SORT_VIDEOS_SCROLL_TOP,
                                  SORT_VIDEOS_SCROLL_DIV_PREFIX);
			}
		} 	
	};
	this.up_keyDown = function(keyCode, item_id){
        if (item_id < 0)
            return
		if (!model_videos.filter_mode){
			if (item_id - this.max_column_number >= 0) {
                var new_first_video_id = get_first_item_id_for_scrolling(item_id,
                                                                         this.max_column_number, 
                                                                         this.max_row_number, 
                                                                         global_videos.first_video_id, 
                                                                         tvKey.KEY_UP);
                if (new_first_video_id != global_videos.first_video_id) {
                    model_videos.first_video_id = new_first_video_id;
                    global_videos.first_video_id = new_first_video_id;
                    view_sort_videos.build_view();
                };
				var trimmed_title = trim_string(model_videos.filtered_current_videos[item_id].video_title, MAX_TRIMMED_TITLE_LENGTH, YES);
				$("#video" + item_id + "_title").html(trimmed_title);
				$("#video" + item_id).removeClass("active");
				item_id = item_id - this.max_column_number;
                alert("item_id = " + item_id)
                global_videos.current_video = item_id;
				$("#video" + item_id).focus();
				$("#video" + item_id).addClass("active");
				var extend_title = trim_string(model_videos.filtered_current_videos[item_id].video_title, MAX_EXTENDED_TITLE_LENGTH, YES);
				$("#video" + item_id + "_title").html(extend_title);
                
                track_bar_drawing(item_id, 
                                  MAX_SORT_VIDEOS_COLS, 
                                  MAX_SORT_VIDEOS_ROWS, 
                                  model_videos.filtered_current_videos_count, 
                                  SORT_VIDEOS_SCROLL_LENGTH, 
                                  SORT_VIDEOS_SCROLL_TOP,
                                  SORT_VIDEOS_SCROLL_DIV_PREFIX);
			}
		} else {
			this.filter_keyDown(keyCode, item_id);
		}
    };
    
	this.down_keyDown = function(keyCode, item_id){
        if (item_id < 0)
            return
		if (!model_videos.filter_mode){
			//if (item_id + this.max_column_number < model_videos.filtered_current_videos_count) {
                var new_first_video_id =  get_first_item_id_for_scrolling(item_id,
                                                                          this.max_column_number, 
                                                                          this.max_row_number, 
                                                                          global_videos.first_video_id, 
                                                                          tvKey.KEY_DOWN);     
                if (new_first_video_id!= global_videos.first_video_id) {
                    model_videos.first_video_id = new_first_video_id;
                    global_videos.first_video_id = new_first_video_id;
                    view_sort_videos.build_view();
                };
                var trimmed_title = trim_string(model_videos.filtered_current_videos[item_id].video_title, MAX_TRIMMED_TITLE_LENGTH, YES);
				$("#video" + item_id + "_title").html(trimmed_title);
				$("#video" + item_id).removeClass("active");
                if (item_id + this.max_column_number < model_videos.filtered_current_videos_count){
                    item_id = item_id + this.max_column_number;
                } else {
                    var last_item_row = Math.floor((model_videos.filtered_current_videos_count - 1)/this.max_column_number) + 1;
                    var current_item_row = Math.floor((item_id)/this.max_column_number) + 1;
                    if (last_item_row > current_item_row){
                        item_id = model_videos.filtered_current_videos_count - 1;
                    }
                }    
                global_videos.current_video = item_id;
				$("#video" + item_id).focus();
				$("#video" + item_id).addClass("active");
				var extend_title = trim_string(model_videos.filtered_current_videos[item_id].video_title, MAX_EXTENDED_TITLE_LENGTH, YES);
				$("#video" + item_id + "_title").html(extend_title);
                
                track_bar_drawing(item_id, 
                                  MAX_SORT_VIDEOS_COLS, 
                                  MAX_SORT_VIDEOS_ROWS, 
                                  model_videos.filtered_current_videos_count, 
                                  SORT_VIDEOS_SCROLL_LENGTH, 
                                  SORT_VIDEOS_SCROLL_TOP,
                                  SORT_VIDEOS_SCROLL_DIV_PREFIX);
                
			//}
		} else {
            this.filter_keyDown(keyCode, item_id);
		}
	};
	this.defaultKeyDown = function(keyCode, item_id){
        switch(keyCode){
            case tvKey.KEY_GREEN:
                if (!model_videos.filter_mode){
                    model_videos.set_filter_mode();
                    for (var counter = SORT_BY_RAITING; counter <= FILTER_ALL_TIME; counter ++){
                        $("#item" + counter + " > span").removeClass("active");
                        $("#item" + counter + " > span").removeClass("selected");
                    }
                    $("#item" + SORT_BY_DATE).focus();
                    $("#item" + SORT_BY_DATE + " > span").addClass("active");
                    $("#item" + global_videos.current_filter+ " > span").addClass("selected");
                    $("#item" + global_videos.current_sort+ " > span").addClass("selected");
                    $("#filter").addClass("visible");
                }
                break;
            case tvKey.KEY_RED:
                if (item_id >= 0)
                    smart_return.push(this.page, 
                                  global_categories.current_category, 
                                  global_videos.current_video, 
                                  global_videos.current_sort, 
                                  global_videos.current_filter,
                                  global_videos.first_video_id);
                global_categories.current_category = 0;
                //global_videos.current_video = -1; RUTUBE-16
                global_videos.current_sort = SORT_BY_DATE;
                global_videos.current_filter = FILTER_ALL_TIME;
                view_categories.build_view(smart_return.can_go_back);
                break;
         }       
	};
	
	this.enter_keyDown = function(keyCode, item_id){
        if (item_id < 0)
            return
		if (model_videos.filter_mode){
			this.filter_keyDown(keyCode, item_id);
		} else {
            controller_sort_videos_prototype.superclass.page = this.page;
            controller_sort_videos_prototype.superclass.enter_keyDown(keyCode, item_id);   
		}
	};
	
	this.return_keyDown = function(keyCode, item_id){
		if (model_videos.filter_mode){
			controller_sort_videos.filter_keyDown(keyCode, item_id);
		} else {
            controller_sort_videos_prototype.superclass.page = this.page;
			controller_sort_videos_prototype.superclass.return_keyDown(keyCode, item_id);
		}
	};    

    this.filter_keyDown = function(keyCode, item_id) {
        switch (keyCode) { 
            case tvKey.KEY_UP:
                if (item_id - FILTER_STEP >= 0) {
                    $("#item" + item_id+ " > span").removeClass("active");
                    item_id -= FILTER_STEP;
                    $("#item" + item_id+ " > span").addClass("active");
                    $("#item" + item_id).focus();
                }
                break;
            case tvKey.KEY_DOWN: 
                if (item_id + FILTER_STEP < FILTER_ITEMS_COUNT) {
                    $("#item" + item_id+ " > span").removeClass("active");
                    item_id += FILTER_STEP;
                    $("#item" + item_id+ " > span").addClass("active");
                    $("#item" + item_id).focus();
                }
                break;
            case tvKey.KEY_ENTER:
                if (item_id <= LAST_SORT_ITEM){
                    for (item_counter = FIRST_SORT_ITEM; item_counter <= LAST_SORT_ITEM; item_counter++){
                        $("#item" + item_counter+ " > span").removeClass("selected");
                    }    
                    $("#item" + item_id+ " > span").addClass("selected");
                    global_videos.current_sort = item_id;
                } else {
                    for (item_counter = FIRST_FILTER_ITEM; item_counter <= LAST_FILTER_ITEM; item_counter++){
                        $("#item" + item_counter+ " > span").removeClass("selected");
                    }    
                    $("#item" + item_id+ " > span").addClass("selected");
                    global_videos.current_filter = item_id;
                }
                break;
           case tvKey.KEY_RETURN:
                model_videos.unset_filter_mode();
                $("#filter").removeClass("visible");
                //global_videos.current_video = -1;    RUTUBE-16
                global_videos.current_video = 0;    // RUTUBE-16
                // Filter and Sorting!!!!
                model_videos.first_video_id = 0;
                global_videos.first_video_id = 0;
                model_videos.filter();
                model_videos.sort();
                view_sort_videos.build_view();
                track_bar_drawing(0, 
                                  MAX_SORT_VIDEOS_COLS, 
                                  MAX_SORT_VIDEOS_ROWS, 
                                  model_videos.filtered_current_videos_count, 
                                  SORT_VIDEOS_SCROLL_LENGTH, 
                                  SORT_VIDEOS_SCROLL_TOP,
                                  SORT_VIDEOS_SCROLL_DIV_PREFIX);
                break;     
        }        
    }
}