function controller_video_prototype() {
    this.page = "video"; 
    this.timer = 0;
    this.current_timer = 0;
    this.return_keyDown = function(keyCode, item_id){
        model_video.stop_video();
        controller_video_prototype.superclass.return_keyDown(keyCode, item_id);
    }
    
    this.right_keyDown = function(keyCode, item_id){
        $("#loading").show();
        $("#label_info_button").show();
        $("#info_button").show();
        model_video.play_next_video(FORWARD);
    }
    
    this.left_keyDown = function(keyCode, item_id){
        $("#loading").show();
        $("#label_info_button").show();
        $("#info_button").show();
        model_video.play_next_video(BACKWARD);
    }
    this.enter_keyDown = function(keyCode, item_id){
        //do nothing!
    }
    this.mute_keyDown = function(keyCode, item_id){
        if((!IS_AV_APPLICATION)){
            //controller_sort_videos_prototype.superclass.mute_keyDown(keyCode, item_id);
            mute_state = !mute_state;
            view_video.move_mute_state();
            view_video.show_mute_state();
            document.getElementById("plugin_object_audio").SetUserMute(mute_state);
        }    
    }
    this.hide_volume_panel = function(parameter){
        if ($("#volume_panel").css("visibility","").is(":hidden") == false){
            view_video.move_volume_panel();
            if (this.timer < 2000){    
                if (parameter != undefined){
                    window.clearTimeout(this.current_timer);
                    var timer_id = window.setInterval("controller_video.hide_volume_panel();",1000);
                    this.timer = 0;
                    this.current_timer = timer_id;
                } else {
                    this.timer += 1000;
                }    
            } else {
                $("#volume_panel").hide();
                this.timer = 0;
                window.clearInterval(this.current_timer);
            }    
        }    
            
    }
    this.refresh_timer = function(){
        this.timer = 0;
        
    }
    this.defaultKeyDown = function(keyCode, item_id) {
        switch(keyCode){
            case tvKey.KEY_PLAY:
                //alert("PLAY");
                $("#label_info_button").show();
                $("#info_button").show();
                this.handle_play_key();
                break;
                
            case tvKey.KEY_STOP: 
                alert("STOP");
                $("#loading").hide();
                model_video.stop_video();
                smart_return.push(this.page, 
                                  global_categories.current_category, 
                                  global_videos.current_video, 
                                  global_videos.current_sort, 
                                  global_videos.current_filter,
                                  0);                
                if (global_videos.current_video != 0) global_videos.first_video_id = 0;
                else global_videos.first_video_id = 1;
                view_see_also_videos.build_view();
                track_bar_drawing(0, 
                                  MAX_SEE_ALSO_VIDEOS_COLS, 
                                  ACTIVE_SEE_ALSO_VIDEOS_ROWS, 
                                  model_videos.filtered_current_videos_count, 
                                  SEE_ALSO_SCROLL_LENGTH, 
                                  SEE_ALSO_SCROLL_TOP,
                                  SEE_ALSO_SCROLL_DIV_PREFIX,
                                  model_video.item_id);
                $("#overseen_video").focus();
                $("#active_main_picture").show();
                break;
                
            case tvKey.KEY_PAUSE:
                alert("PAUSE");
                this.handle_pause_key();
                $("#label_info_button").hide();
                $("#info_button").hide();
                break;
                
            case tvKey.KEY_FF:
                alert("FF");
                model_video.skip_forward_video();
                break;
            
            case tvKey.KEY_RW:
                alert("RW");        
                model_video.skip_backward_video();
                break;
                
            case tvKey.KEY_BLUE:
                if (model_video.pause_video()) {
                    view_video.show_hide_info();
                    view_video.move_volume_panel();
                    $("#label_info_button").hide();
                    $("#info_button").hide();
                }    
                break;
                
            case tvKey.KEY_VOL_UP:
            case tvKey.KEY_PANEL_VOL_UP:
                if(!IS_AV_APPLICATION){
                    if (mute_state){
                        this.mute_keyDown();
                    }
                    $("#volume_panel").show();
                    view_video.move_volume_panel();
                    document.getElementById("plugin_object_audio").SetVolumeWithKey(AUDIO_VOLUME_KEY_UP);
                    $("#volume_value").width(document.getElementById("plugin_object_audio").GetVolume() * 3);
                    controller_video.hide_volume_panel(tvKey.KEY_VOL_UP);
                    this.refresh_timer();
                }    
                break;
            case tvKey.KEY_VOL_DOWN:
            case tvKey.KEY_PANEL_VOL_DOWN:
                if (!IS_AV_APPLICATION){
                    if (mute_state){
                        this.mute_keyDown();
                    }
                    $("#volume_panel").show();
                    view_video.move_volume_panel();
                    document.getElementById("plugin_object_audio").SetVolumeWithKey(AUDIO_VOLUME_KEY_DOWN);
                    $("#volume_value").width(document.getElementById("plugin_object_audio").GetVolume() * ONE_VOLUME_STEP_WIDTH);
                    controller_video.hide_volume_panel(tvKey.KEY_VOL_DOWN);
                    this.refresh_timer();
                }    
                break;    
            default:
                alert("Unhandled key");
                break;
        }
    };
    
    this.handle_play_key = function(){
        switch ( model_video.get_state() ){
            case PLAYER_STOPPED:
                if (model_video.play_video()) {
                    view_video.show_hide_info();
                    view_video.move_volume_panel();
                }    
                break;
                
            case PLAYER_PAUSED:
                model_video.resume_video();
                view_video.show_hide_info();
                break;
                
            default:
                alert("Ignoring play key, not in correct state");
                break;
        }
    };
    
    this.handle_pause_key = function(){
        switch ( model_video.get_state() ){
            case PLAYER_PLAYING:
                if (model_video.pause_video())  {
                    view_video.show_hide_info();
                    view_video.move_volume_panel();
                }    
                break;
                
            case PLAYER_PAUSED:
               model_video.resume_video();
               view_video.show_hide_info();
               break;
            
            default:
                alert("Ignoring pause key, not in correct state");
                break;
        }
    }
}