/**
 * @author ATSTeam
 */
function page_controller(page_name, max_col_num, element_count){
    this.page = page_name;
    this.max_column_number = max_col_num;
    this.element_count = element_count;
	this.element_name = "";
}    

page_controller.prototype.keyDown = function(keyCode, item_id){
    var col_num = item_id % this.max_column_number;
    this.element_name = "#" + page_element_association[this.page];
    var line_num = (item_id - col_num) / this.max_column_number;
    switch (keyCode) {
        case tvKey.KEY_PANEL_ENTER:
		case tvKey.KEY_ENTER:
			this.enter_keyDown(keyCode, item_id);
			break;
            
        case tvKey.KEY_PANEL_RETURN:    
		case tvKey.KEY_RETURN:
            widgetAPI.blockNavigation(event);
            this.return_keyDown(keyCode, item_id);
			break;	
            
        case tvKey.KEY_LEFT: 
			this.left_keyDown(keyCode, item_id);
            break;
            
        case tvKey.KEY_RIGHT:
			this.right_keyDown(keyCode, item_id);
            break;
            
        case tvKey.KEY_UP: 
			this.up_keyDown(keyCode, item_id);
            break;
            
        case tvKey.KEY_DOWN:
			this.down_keyDown(keyCode, item_id);
            break;
            
        case tvKey.KEY_MUTE:
            this.mute_keyDown(keyCode, item_id);
            break;
        case KEY_SMART_HUB:    
        case KEY_INTERNET_TV:
        case tvKey.KEY_EXIT:
            widgetAPI.sendExitEvent();
            break;
        default:
            this.defaultKeyDown(keyCode, item_id);
            break;
    }
}

page_controller.prototype.enter_keyDown = function(keyCode, item_id){
    $("#load_focus").focus();
    $("#loading").show();
	switch (this.page){
		case "category":
            global_videos.current_video = item_id;
            smart_return.push(this.page, 
                              global_categories.current_category, 
                              global_videos.current_video, 
                              global_videos.current_sort, 
                              global_videos.current_filter,
                              global_videos.first_video_id);
			controller.clear_view();
            model_video.init(item_id, model_videos.filtered_current_videos[item_id]);
            view_video.build_view();
            model_video.play_video();
			break;
		case "video_category":
            smart_return.push(this.page, 
                              global_categories.current_category, 
                              global_videos.current_video, 
                              global_videos.current_sort, 
                              global_videos.current_filter,
                              global_videos.first_video_id);
			controller.clear_view();
            model_video.init(global_videos.current_video, model_videos.filtered_current_videos[global_videos.current_video]);
			view_video.build_view();
            
            var TV_plugin = document.getElementById("plugin_object_TV");
            model_video.play_video();
			break;
		case "video":
            smart_return.push(this.page, 
                              global_categories.current_category, 
                              global_videos.current_video, 
                              global_videos.current_sort, 
                              global_videos.current_filter,
                              0);
			break;
		case "category_list":
            global_categories.current_category = item_id;
            global_videos.current_video = 0;
            smart_return.push(this.page, 
                              global_categories.current_category, 
                              global_videos.current_video, 
                              global_videos.current_sort, 
                              global_videos.current_filter,
                              global_videos.first_video_id);
			controller.clear_view();
            model_videos.add(item_id);
            model_videos.first_video_id = 0;
            global_videos.first_video_id = 0;
			view_sort_videos.build_view(smart_return.can_go_back());
            track_bar_drawing(global_videos.current_video, 
                              MAX_SORT_VIDEOS_COLS, 
                              MAX_SORT_VIDEOS_ROWS, 
                              model_videos.filtered_current_videos_count, 
                              SORT_VIDEOS_SCROLL_LENGTH, 
                              SORT_VIDEOS_SCROLL_TOP,
                              SORT_VIDEOS_SCROLL_DIV_PREFIX);
			break;    
	}
} 

page_controller.prototype.return_keyDown = function(keyCode, item_id){
    if (smart_return.can_go_back()){
        var page_name = smart_return.pop();
        switch (page_name){
            case "category":
                controller.clear_view();
                view_sort_videos.build_view();
                track_bar_drawing(global_videos.current_video, 
                                  MAX_SORT_VIDEOS_COLS, 
                                  MAX_SORT_VIDEOS_ROWS, 
                                  model_videos.filtered_current_videos_count, 
                                  SORT_VIDEOS_SCROLL_LENGTH, 
                                  SORT_VIDEOS_SCROLL_TOP,
                                  SORT_VIDEOS_SCROLL_DIV_PREFIX);
                break;
            case "video_category":
                controller.clear_view();
                model_video.fill_video_fields(smart_return.get_previous_video(), model_videos.filtered_current_videos[smart_return.get_previous_video()]);
                view_see_also_videos.build_view();
                if (global_videos.current_video == model_video.item_id) {
                    $("#overseen_video").focus();
                    $("#active_main_picture").show();
                } else {
                    $("#video" + global_videos.current_video).focus();
                    $("#video" + global_videos.current_video).addClass("active");
                    var extend_title = trim_string(model_videos.filtered_current_videos[global_videos.current_video].video_title, MAX_EXTENDED_TITLE_LENGTH, YES);
                    $("#video" + global_videos.current_video + "_title").html(extend_title);
                }
                track_bar_drawing(global_videos.current_video, 
                                  MAX_SEE_ALSO_VIDEOS_COLS, 
                                  ACTIVE_SEE_ALSO_VIDEOS_ROWS, 
                                  model_videos.filtered_current_videos_count, 
                                  SEE_ALSO_SCROLL_LENGTH, 
                                  SEE_ALSO_SCROLL_TOP,
                                  SEE_ALSO_SCROLL_DIV_PREFIX,
                                  model_video.item_id);
                break;
            case "video":
                controller.clear_view();
                model_video.fill_video_fields(global_videos.current_video, model_videos.filtered_current_videos[global_videos.current_video]);
                view_video.build_view();
                model_video.stop_video();
                model_video.play_video();
                break;
            case "category_list":
                controller.clear_view();
                view_categories.build_view(smart_return.can_go_back());
                break;
        }
    } else {
        widgetAPI.sendReturnEvent();
    }
} 

page_controller.prototype.left_keyDown = function(keyCode, item_id){
	if (item_id > 0) {
		$(this.element_name + item_id).removeClass("active");
		item_id--;
		$(this.element_name + item_id).focus();
		$(this.element_name + item_id).addClass("active");
	}
} 

page_controller.prototype.right_keyDown = function(keyCode, item_id){
	if (item_id < (this.element_count - 1)) {
		$(this.element_name + item_id).removeClass("active");
		item_id++;
		$(this.element_name + item_id).focus();
		$(this.element_name + item_id).addClass("active");
	}
} 

page_controller.prototype.up_keyDown = function(keyCode, item_id){
	if (item_id - this.max_column_number >= 0) {
		$(this.element_name + item_id).removeClass("active");
		item_id = item_id - this.max_column_number;
		$(this.element_name + item_id).focus();
		$(this.element_name + item_id).addClass("active");
	}
} 

page_controller.prototype.down_keyDown = function(keyCode, item_id){
    if (item_id + this.max_column_number < this.element_count) {
		$(this.element_name + item_id).removeClass("active");
		item_id = item_id + this.max_column_number;
		$(this.element_name + item_id).focus();
		$(this.element_name + item_id).addClass("active");
	}
}  

page_controller.prototype.mute_keyDown = function(keyCode, item_id){
    //if(!IS_AV_APPLICATION){
    //    mute_state = !mute_state;
    //}
    //do nothing - correct!
}

page_controller.prototype.defaultKeyDown = function(){
    //do nothing - it is correct.
}