/**
 * @author ATSTeam
 */
function model_video_prototype () {
	this.video_list = new Array();
    this.plugin = null;
    this.state = -1;
    this.original_source = null;
    this.total_time = 0;
    this.loaded_percent = 0;
    this.played_percent = 0;
    this.played_time = 0;
    this.video_array = new Array();
	
    this.item_id = -1;
    
    this.video_id = -1;
    this.video_title = ""; 
    this.video_url = "";
    this.video_image = ""; 
    this.video_popularity = 0;
    this.video_create_date  = 0;
    this.video_description = ""; 
    this.video_duration = 0;
    this.video_category_priority = 0;
    
	//functions adds category to the collection distinctly
	this.init = function (item_id, video_array) {
        this.state = PLAYER_STOPPED;
        this.plugin = document.getElementById("plugin_player");
        this.plugin.SetDisplayArea(31, 0, 898, 505);
        this.plugin.OnConnectionFailed='model_video.on_connection_failed';
        this.plugin.OnNetworkDisconnected = 'model_video.on_network_disconnected';
        this.plugin.onServerError ='model_video.on_server_error';
        this.plugin.OnStreamNotFound ='model_video.on_stream_not_found';
        this.plugin.OnRenderError = 'model_video.on_render_error';
        
        this.plugin.OnCurrentPlayTime = 'model_video.set_cur_time';
        this.plugin.OnBufferingStart  = 'model_video.on_buffering_start';
        this.plugin.OnBufferingProgress = 'model_video.on_buffering_progress';
        this.plugin.OnBufferingComplete = 'model_video.on_buffering_complete'; 
        this.plugin.OnRenderingComplete = 'model_video.on_render_complete';
        this.fill_video_fields(item_id, video_array);
    };
    
    this.on_render_error = function(){
        //on_render_error
        //alert("on_render_error");
        this.display_error_screen();
    }
    this.on_stream_not_found = function(){
        //on_stream_not_found
        //alert("on_stream_not_found");
        this.display_error_screen();
    }
    this.on_server_error = function(){
        //on_server_error
        //alert("on_server_error");
        this.display_error_screen();
    }
    this.on_connection_failed = function(){
        //on_connection_failed
        //alert("on_connection_failed");
        this.display_error_screen();
    }
    this.on_network_disconnected = function(){
        //on_network_disconnected
        //alert("on_network_disconnected");
        this.display_error_screen();
    }
    
    this.display_error_screen = function(){
        $("#error").show();
        $("#error_link").focus();
        model_video.stop_video();
    }
    
    this.on_render_complete = function(){
        var played_width = 303;
        var loaded_width = 0;
        $("#current_time").html("0:00");
        $("#total_time").html("0:00");
        $("#time_panel_play_progress").width(played_width);
        $("#time_panel_load_progress").width(loaded_width);
        $("#loading").show();
        controller_sort_videos_prototype.superclass.page = "video";
        controller_sort_videos_prototype.superclass.enter_keyDown(tvKey.KEY_RIGHT, this.item_id);
        this.play_next_video(FORWARD);
    }
    
    this.fill_video_fields = function (item_id, video_array){
        this.played_time = 0;
        this.item_id = item_id;
        this.video_id = video_array.video_id; 
        this.video_title = video_array.video_title; 
        this.video_url = video_array.video_url; 
        this.video_image = video_array.video_image; 
        this.video_popularity = video_array.video_popularity;
        this.video_rating = video_array.video_rating;
        this.video_create_date  = video_array.video_create_date;
        this.video_description = video_array.video_description; 
        this.video_duration = video_array.video_duration;
        this.video_category_priority = video_array.video_category_priority;
    }
    
    this.play_next_video = function(direction){
        $("#loading").show();        
        this.played_percent = 0;
        this.loaded_percent = 0;
        this.played_time = 0;
        this.total_time = 0;
        this.refresh_time_panel();
        var next_video_id = -1;
        if (direction == FORWARD){
            if (global_videos.current_video != model_videos.filtered_current_videos_count -1)
                next_video_id = global_videos.current_video + 1;
            else    
                next_video_id = 0;
        }
        if (direction == BACKWARD){
            if (global_videos.current_video == 0)
                next_video_id = model_videos.filtered_current_videos_count -1;
            else    
                next_video_id = global_videos.current_video - 1;
        }
        global_videos.current_video = next_video_id;          
        this.fill_video_fields(next_video_id, model_videos.filtered_current_videos[next_video_id]);
        view_video.build_view();
        this.stop_video();
        this.play_video();
    }
    
    this.refresh_time_panel = function (){
        var played_width = Math.round((303 * this.played_percent)/100);
        var loaded_width = Math.round((303 * this.loaded_percent)/100) - played_width;
        $("#time_panel_play_progress").width(played_width);
        $("#time_panel_load_progress").width(loaded_width); 
    }
    
    this.play_video = function(){
        if (this.video_url == null){
            alert("No videos to play");
        } else{
            this.state = PLAYER_PLAYING;
            $("#error").hide();
            this.plugin.Play( this.video_url );
            pluginAPI.setOffScreenSaver(); 
        }
    };
    
    this.on_buffering_start = function(){
        $("#loading").show();
    };
    
    this.on_buffering_progress = function(percent){
        this.loaded_percent = percent;
        this.refresh_time_panel();
    };
	
    this.on_buffering_complete = function(){
        this.loaded_percent = 100;
        this.refresh_time_panel();
        this.total_time = this.plugin.GetDuration();
        $("#loading").hide();
        $("#single_video").focus();
    };

    this.set_cur_time = function(time){
        $("#current_time").html(format_time(Math.floor(time/1000)));
        this.played_time = time;
        this.played_percent = Math.round(time/this.plugin.GetDuration()* 100);
        this.refresh_time_panel();
    };
    this.deinit = function(){     
        if (this.plugin){
            this.plugin.Stop();
        }
    };
    
    this.pause_video = function(){
        if (this.state != PLAYER_PAUSED){
            this.state = PLAYER_PAUSED;
            this.plugin.Pause();
            pluginAPI.setOnScreenSaver();
            return true;
        } else return false;    
    };

    this.stop_video = function(){
        if (this.state != PLAYER_STOPPED){
            this.state = PLAYER_STOPPED;
            this.plugin.Stop();
            pluginAPI.setOnScreenSaver()
            return true;
        } else return false;
    };

    this.resume_video = function(){
        this.state = PLAYER_PLAYING;
        this.plugin.Resume();
        pluginAPI.setOffScreenSaver();
        //alert("Playing...");
    };

    this.skip_forward_video = function(){
        this.plugin.JumpForward(5);
    };

    this.skip_backward_video = function(){
        this.plugin.JumpBackward(5);
    };

    this.get_state = function(){
        return this.state;
    };
    
} 
