/**
 * @author ATSTeam
 */
function model_videos_prototype () { 
    this.filter_mode = false;
	this.current_videos = new Array();
    this.filtered_current_videos = new Array();
	this.current_videos_count = 0;
    this.filtered_current_videos_count = 0;
    this.first_video_id = 0;
    
    this.add = function (category_num) {
        
        this.current_videos = global_videos.videos_array[category_num];
        this.filtered_current_videos = global_videos.videos_array[category_num];
        this.current_videos_count = this.current_videos.length;
        this.filtered_current_videos_count = this.filtered_current_videos.length;
    };
    
    this.filter = function (){
        this.filtered_current_videos = new Array();
        this.filtered_current_videos_count = 0;
        switch (global_videos.current_filter){
            case FILTER_TODAY:
                //alert("FILTER_TODAY");
                var now = new Date();
                var week_day = now.getDay();
                var current_day = new Date(now.getFullYear(), now.getMonth(), now.getDate());
                var first_week_day = new Date(current_day - (week_day - 1)*24*60*60*1000);
                for (var counter = 0; counter < this.current_videos_count; counter ++){
                    if (this.current_videos[counter].video_create_date > current_day){
                        this.filtered_current_videos.push(this.current_videos[counter]);
                        this.filtered_current_videos_count++;
                    }
                }
                break;
            case FILTER_WEEK:
                //alert("FILTER_WEEK");
                var now = new Date();
                var week_day = now.getDay();
                var current_day = new Date(now.getFullYear(), now.getMonth(), now.getDate()); 
                if (week_day == 0) {
                    week_day = 7;
                }
                var first_week_day = new Date(current_day - (week_day - 1)*24*60*60*1000);
                for (var counter = 0; counter < this.current_videos_count; counter ++){
                    if (this.current_videos[counter].video_create_date > first_week_day){
                        this.filtered_current_videos.push(this.current_videos[counter]);
                        this.filtered_current_videos_count++;
                    }
                }
                break;
            case FILTER_MONTH:
                //alert("FILTER_MONTH");
                var now = new Date();
                var week_day = now.getDay();
                var current_month = new Date(now.getFullYear(), now.getMonth()); 
                var first_week_day = new Date(current_day - (week_day - 1)*24*60*60*1000);
                for (var counter = 0; counter < this.current_videos_count; counter ++){
                    if (this.current_videos[counter].video_create_date > current_month){
                        this.filtered_current_videos.push(this.current_videos[counter]);
                        this.filtered_current_videos_count++;
                    }
                }
                break;
            case FILTER_ALL_TIME:
                //alert("FILTER_ALL_TIME");
                this.filtered_current_videos = this.current_videos;
                this.filtered_current_videos_count = this.current_videos_count;
                break;
        }
        if (this.filtered_current_videos_count == 0){
            global_videos.current_video = -1;
        }
    };
	
    this.sort = function (){
        switch (global_videos.current_sort){
            /*case SORT_BY_VIEWS:
                //alert("SORT_BY_VIEWS");
                this.filtered_current_videos.sort(function(value1, value2){
                    if (value1.video_views <= value2.video_views) return 1;
                    else return -1;
                });
                break;*/
            case SORT_BY_RAITING:
                //alert("SORT_BY_RAITING");
                this.filtered_current_videos.sort(function(value1, value2){
                    if (value1.video_popularity <= value2.video_popularity) return 1;
                    else return -1;
                });
                break;
            case SORT_BY_DATE:
                //alert("SORT_BY_DATE");
                this.filtered_current_videos.sort(function(value1, value2){
                    if (value1.video_create_date <= value2.video_create_date) return 1;
                    else return -1;
                });
                break;
        };
        
    };
	
    this.set_filter_mode = function (){
        this.filter_mode = true;
    };
	
    this.unset_filter_mode = function(){
        this.filter_mode = false;
    };
}    